import { Action, StateCrudAction, MappingAction, ContainerPostReducer, AnyMappingAction } from './actions/actions';
import { ContainerComponent } from './components/ContainerComponent';
import { RenderPropsComponent, ContainerRenderProps } from './components/RenderPropsComponent';
import { Store, StateObject, State, StateParent, StateProp, StateConfigOptions, getStateObject } from './types/Store';
import { ArrayChangeAction } from './actions/actions';
import { getActionCreator, getArrayActionCreator, getMappingActionCreator, getArrayMappingActionCreator }
  from './actions/actionCreators';
import { Manager } from './types/Manager';
import { ActionProcessorFunctionType, DataTrigger } from './types/ActionProcessor';

/**
 * This is intended to be a list of objects you will need to use the library as-is.
 * For more advanced usage, others are available via direct reference, and examples
 * of usage should be in the unit tests.
 */
export {
  Store,
  State,
  StateParent,
  StateConfigOptions,
  StateProp,
  StateObject,
  Action,
  ActionProcessorFunctionType,
  DataTrigger,
  getStateObject,
  getActionCreator,
  getArrayActionCreator,
  getMappingActionCreator,
  getArrayMappingActionCreator,
  StateCrudAction,
  ArrayChangeAction,
  Manager,
  MappingAction,
  AnyMappingAction,
  ContainerPostReducer,
  ContainerComponent,
  RenderPropsComponent,
  ContainerRenderProps
};
